# class Prism::StatementsNode

Represents a set of statements contained within some scope.

    foo; bar; baz
    ^^^^^^^^^^^^^

### Attributes

body [R]

attr_reader body: Array

### Public Class Methods

new (source, node_id, location, flags, body)
Source

    # File lib/prism/node.rb, line 16766
    def initialize(source, node_id, location, flags, body)
      @source = source
      @node_id = node_id
      @location = location
      @flags = flags
      @body = body
    end

Initialize a new `StatementsNode` node.

type ()
Source

    # File lib/prism/node.rb, line 16821
    def self.type
      :statements_node
    end

Return a symbol representation of this node type. See ‘Node::type`.

### Public Instance Methods

=== (other)
Source

    # File lib/prism/node.rb, line 16827
    def ===(other)
      other.is_a?(StatementsNode) &&
        (body.length == other.body.length) &&
        body.zip(other.body).all? { |left, right| left === right }
    end

Implements case-equality for the node. This is effectively == but without comparing the value of locations. Locations are checked only for presence.

accept (visitor)
Source

    # File lib/prism/node.rb, line 16775
    def accept(visitor)
      visitor.visit_statements_node(self)
    end

def accept: (`Visitor` visitor) -> void

child_nodes ()
Source

    # File lib/prism/node.rb, line 16780
    def child_nodes
      [*body]
    end

def `child_nodes`: () -> Array[nil | Node]

Also aliased as: deconstruct
comment_targets ()
Source

    # File lib/prism/node.rb, line 16790
    def comment_targets
      [*body] #: Array[Prism::node | Location]
    end

def `comment_targets`: () -> Array[Node | Location]

compact_child_nodes ()
Source

    # File lib/prism/node.rb, line 16785
    def compact_child_nodes
      [*body]
    end

def `compact_child_nodes`: () -> Array

copy (node_id: self.node_id, location: self.location, flags: self.flags, body: self.body)
Source

    # File lib/prism/node.rb, line 16795
    def copy(node_id: self.node_id, location: self.location, flags: self.flags, body: self.body)
      StatementsNode.new(source, node_id, location, flags, body)
    end

def copy: (?node_id: `Integer`, ?location: `Location`, ?flags: `Integer`, ?body: Array) -> `StatementsNode`

deconstruct ()

def deconstruct: () -> Array[nil | Node]

Alias for: child_nodes
deconstruct_keys (keys)
Source

    # File lib/prism/node.rb, line 16803
    def deconstruct_keys(keys)
      { node_id: node_id, location: location, body: body }
    end

def `deconstruct_keys`: (Array keys) -> { node_id: `Integer`, location: `Location`, body: Array }

inspect ()
Source

    # File lib/prism/node.rb, line 16811
    def inspect
      InspectVisitor.compose(self)
    end

def inspect -> `String`

type ()
Source

    # File lib/prism/node.rb, line 16816
    def type
      :statements_node
    end

Return a symbol representation of this node type. See ‘Node#type`.